=== modified file 'NEWS'
--- NEWS	2009-05-17 11:10:38 +0000
+++ NEWS	2009-05-27 15:57:20 +0000
@@ -115,6 +115,9 @@
 
     - Fix 'bzr serve --http' errors. (Matt Nordhoff, #377551)
 
+    - Fix serving branches over HTTP. (Matt Nordhoff, Jelmer Vernooij,
+      #380026)
+
 1.10 [22Dec2008]
 ---------------
 

=== modified file 'loggerhead/apps/transport.py'
--- loggerhead/apps/transport.py	2009-05-04 20:28:50 +0000
+++ loggerhead/apps/transport.py	2009-05-25 01:03:25 +0000
@@ -82,8 +82,15 @@
         elif environ['PATH_INFO'] == '/favicon.ico':
             return favicon_app(environ, start_response)
         elif '/.bzr/' in environ['PATH_INFO']:
-            app = urlparser.make_static(None, self.transport)
-            return app(environ, start_response)
+            # TODO: Use something here that uses the transport API 
+            # rather than relying on the local filesystem API.
+            try:
+                path = urlutils.local_path_from_url(self.transport.base)
+            except errors.InvalidURL:
+                raise httpexceptions.HTTPNotFound()
+            else:
+                app = urlparser.make_static(None, path)
+                return app(environ, start_response)
         else:
             return BranchesFromTransportServer(
                 self.transport, self)(environ, start_response)

